#ifndef __PRIVATEKEY_HPP
#define __PRIVATEKEY_HPP

#include "Fp.hpp"
#include "Bipoint.hpp"
#include "Quadripoint.hpp"
#include "fp12e.h"

class PrivateKey
{
    public:
        PrivateKey() = default; 
        PrivateKey(const Fp& a, const Fp& b, const Fp& c, const Fp& d, const Fp& e, const Fp& f, const Fp& g, const Fp& h);

        void set(const Fp& a, const Fp& b, const Fp& c, const Fp& d, const Fp& e, const Fp& f, const Fp& g, const Fp& h);
        void set(string which, const Fp& input);
        Fp get(string which) const;
        
        Bipoint<curvepoint_fp_t>  pi_1(const Bipoint<curvepoint_fp_t>& input) const;
        Bipoint<twistpoint_fp2_t> pi_2(const Bipoint<twistpoint_fp2_t>& input) const;
        Quadripoint pi_T(const Quadripoint& input) const;
    
    private:
        Fp i1, j1, k1, l1, i2, j2, k2, l2;
};

#endif
